Name: jdkgcj
Version: 0.3.3
Release: alt16

Summary: A free Java SDK
License: GPL
Group: Development/Java
Url: http://www.arklinux.org/projects/jdkgcj
Packager: Dmitry V. Levin <ldv@altlinux.org>

%define origin	    gcj
%define javaver	    1.5.0
%define java_home   %_jvmdir/%name
%define sdkbindir   %java_home/bin
%define jrebindir   %java_home/jre/bin
%define priority 1200

Requires: gcc%__gcc_version_base-java = %__gcc_version
Requires: gcc-java-common >= 1.4.12-alt1
Requires: java-common >= 1.1
BuildRequires(pre): alternatives >= 0:0.4
BuildRequires(pre): rpm-build-java

Source: %name-%version.tar
Source1: %name-notimpl.sh
Source2: %name-refentry.xml

%set_compress_method gzip

BuildRequires: gcc%__gcc_version_base-java xmlto

%description
jdkgcj provides an interface to gcj that is compatible with the Sun and IBM
Java Development Kits (JDKs).
jdkgcj provides the javac, java and javah tools as well as jni.h, allowing
you to compile java extensions using JNI.

%prep
%setup -q -n %name

%build
%configure \
	--prefix=%java_home \
	--bindir=%sdkbindir \
	--includedir=%java_home/include
xmlto -o man man %SOURCE2

%install
rln()
{
	local target=$1 && shift
	local source=$1 && shift
	target=`relative "$target" "$source"`
	ln -snf "$target" "%buildroot$source"
}
%make_install install DESTDIR=%buildroot
rln %_bindir/fastjar %sdkbindir/jar
for i in appletviewer keytool jarsigner javah rmic; do
	rln %_bindir/gcj %sdkbindir/$i
done

install -p -m755 %SOURCE1 %buildroot%sdkbindir/notimpl
mkdir -p %buildroot%java_home/man/man1
install -pm644 man/javac.1 %buildroot%java_home/man/man1/jdkgcj.1
for f in javac javah jar rmic; do
	ln -s jdkgcj.1 %buildroot%java_home/man/man1/"$f".1
done

gcj_target_libdir=`gcj -print-search-dirs |sed -ne 's|^install: \(/.*\)/$|\1|p'`
for f in java javax jvmpi.h; do
	rln "$gcj_target_libdir/include/$f" %java_home/include/
done

for i in extcheck idlj javadoc javap jdb native2ascii serialver; do
	ln -snf notimpl %buildroot%sdkbindir/$i
done

# jre dir and stuff
mkdir -p %buildroot%jrebindir
pushd %buildroot%sdkbindir
    for i in java \
    keytool policytool servertool pack200 unpack200 \
    orbd rmid rmiregistry tnameserv
    do 
     	 [ -e "$i" ] && ln -s ../../bin/$i %buildroot%jrebindir/
    done
popd

mkdir -p %buildroot%_altdir

# jre alternative
%__cat <<EOF >%buildroot%_altdir/%name-java
%{_bindir}/java	%{jrebindir}/java	%priority
%_man1dir/java.1.gz	%java_home/man/man1/java.1.gz	%{jrebindir}/java
EOF
# binaries and manuals
for i in keytool policytool servertool pack200 unpack200 \
orbd rmid rmiregistry tnameserv
do
  [ -L %buildroot%jrebindir"$i" ] || [ -e %buildroot%jrebindir"$i" ] && \
  %__cat <<EOF >>%buildroot%_altdir/%name-java
%_bindir/$i	%jrebindir/$i	%{jrebindir}/java
EOF
  [ -L %java_home/man/man1/$i.1.gz ] || [ -e %java_home/man/man1/$i.1.gz ] && \
  %__cat <<EOF >>%buildroot%_altdir/%name-java
%_man1dir/$i.1.gz	%java_home/man/man1/$i.1.gz	%{jrebindir}/java
EOF
done

# javac alternative and manual
cat <<EOF>%buildroot%_altdir/%name-javac
%_bindir/javac	%sdkbindir/javac	%priority
%_man1dir/javac.1.gz	%java_home/man/man1/javac.1.gz	%sdkbindir/javac
EOF
# binaries and manuals
for i in appletviewer extcheck idlj jar jarsigner javadoc javah javap jdb native2ascii rmic serialver apt jconsole jinfo jmap jps jsadebugd jstack jstat jstatd \
jhat jrunscript jvisualvm schemagen wsgen wsimport xjc \
HtmlConverter
do
  [ -L $RPM_BUILD_ROOT%sdkbindir/$i ] || [ -e $RPM_BUILD_ROOT%sdkbindir/$i ] && \
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%_bindir/$i	%sdkbindir/$i	%sdkbindir/javac
EOF
  [ -L $RPM_BUILD_ROOT%sdkbindir/$i ] || [ -e $RPM_BUILD_ROOT%java_home/man/man1/$i.1.gz ] && \
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%_man1dir/$i.1.gz	%java_home/man/man1/$i.1.gz	%sdkbindir/javac
EOF
done
# ----- JPackage compatibility alternatives ------
  %__cat <<EOF >>%buildroot%_altdir/%name-javac
%{_jvmdir}/java	%java_home	%sdkbindir/javac
%{_jvmdir}/java-%{origin}	%java_home	%sdkbindir/javac
%{_jvmdir}/java-%{javaver}	%java_home	%sdkbindir/javac
EOF

%files
%_altdir/%name-java
%_altdir/%name-javac
%java_home

%changelog
* Fri Nov 28 2008 Igor Vlasenko <viy@altlinux.ru> 0.3.3-alt16
- added /usr/lib/jvm/java alternative

* Fri Nov 28 2008 Igor Vlasenko <viy@altlinux.ru> 0.3.3-alt15
- rewritten alternatives to be compatible with java-*-sun ones.

* Thu Oct 30 2008 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt14
- Fixed links: appletviewer keytool jarsigner.
- Fixed gcc-4.3+ support in java and javac wrappers.

* Wed Oct 22 2008 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt13
- Rebuilt with gcc-4.3.2.

* Thu Oct 09 2008 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt12
- Changed %%jdkgcj_home/bin/jar symlink to point to %_bindir/fastjar.

* Fri Feb 22 2008 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt11
- Workaround old broken docbook-style-xsl.

* Thu Feb 21 2008 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt10
- Rebuilt with gcc-4.1.2.

* Thu May 25 2006 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt9
- Rebuilt with gcc-4.1.1.

* Fri May 12 2006 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt8
- Rebuilt with gcc-4.1.0.

* Thu Mar 09 2006 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt7
- Rebuilt with gcc-3.4.5.
- Updated build dependencies.

* Sat Oct 08 2005 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt6
- Changed %%jdkgcj_home to /usr/lib/%name.
- Converted rest of absolute symlinks into relative.

* Sun Aug 21 2005 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt5
- Simplified targets of %%jdkgcj_home/bin/{javah,jar,rmic} symlinks.

* Thu Jun 23 2005 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt4
- Converted alternatives config file to new format (0.2.0).
- Rebuilt with gcc-3.4.4.
- Removed noarch tag.

* Tue Jan 18 2005 Dmitry V. Levin <ldv@altlinux.org> 0.3.3-alt3
- Fixed alternatives.
- Rebuilt with gcc-3.4.3.

* Wed Jun 16 2004 Stanislav Ievlev <inger@altlinux.org> 0.3.3-alt2.1
- NMU: move to new alternatives scheme

* Sun Mar 07 2004 Mikhail Zabaluev <mhz@altlinux.ru> 0.3.3-alt2
- Requires java-common

* Sat Jan 17 2004 Mikhail Zabaluev <mhz@altlinux.ru> 0.3.3-alt1
- Updated to the upstream release 0.3.3, using cues from spec by Arklinux
- Install a stub script for the executable JDK alternatives missing in jdkgcj
- Provide a manpage to override the JDK manpage alternatives and say something
  about jdkgcj

* Sat Jan 03 2004 Dmitry V. Levin <ldv@altlinux.org> 0.2.3-alt5
- Rebuilt with gcc-3.3.3

* Tue Dec 30 2003 Dmitry V. Levin <ldv@altlinux.org> 0.2.3-alt4
- Rebuilt with gcc-3.3.2

* Mon Jun 30 2003 Dmitry V. Levin <ldv@altlinux.org> 0.2.3-alt3
- Rebuilt with gcc-3.2.3

* Tue Nov 12 2002 Dmitry V. Levin <ldv@altlinux.org> 0.2.3-alt2
- Specfile cleanup.
- Use libgcj version in emulation scripts.
- Fixed tmp handling in java emulation.

* Mon Nov 11 2002 AEN <aen@altlinux.ru> 0.2.3-alt1
- first build (RH package)

* Mon Jul 29 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.2.3-1
- Adapt to gcc 3.2 (#69948)

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Jun 13 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.2.2-1
- Handle weirdo options like "-D ."

* Wed Jun 12 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.2.1-1
- Fix passing of parameters containing spaces or quotes to java
  applications.

* Fri May 31 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.2.0-1
- Replace the java->gij symlink with a script that translates
  java options to gij options (allowing stuff like
  java -classpath "/foo" -Djava.library.path=/bar some/sub/class
  to work)

* Fri May 31 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.1.1-1
- Fix up default location of gcj jar file

* Fri May 31 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.1.0-1
- Fix up -d support in javac. It must handle multiple classes per file.

* Fri May 31 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.0.2-1
- Add support for -d in javac

* Fri May 31 2002 Bernhard Rosenkraenzer <bero@redhat.com> 0.0.1-1
- initial RPM
